/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System;using System.Collections;using System.Collections.Generic;namespace PluginIdea.NavgatePlay{public class AnimatorPlayer : PLModuleBase{private Animator animator;private Queue<AnimatorPlayInfo> animatorPlayQueue;private AnimatorPlayInfo currentAnimatorPlayInfo;private bool isCurrentStatePlayFinished;public class CrossFadeType{public const int NONE = 0;public const int NORMAL = 1;}public class AnimatorPlayInfo{public int fadeType = CrossFadeType.NONE;public string stateName = "";public float speed = 1;public int layer = 0;public float beginTimeNormalized = 0;public float endTimeNormalized = 1;public bool isClearStateExists = true;public Action onPlayFinished;}public override void Init(NavgatePlay ower, params object[] args){base.Init(ower, args);this.animatorPlayQueue = new Queue<AnimatorPlayInfo>();this.animator = args[0] as Animator;this.isCurrentStatePlayFinished = true;}public override void OnUpdate(){base.OnUpdate();if (this.animatorPlayQueue.Count > 0 && isCurrentStatePlayFinished){currentAnimatorPlayInfo = this.animatorPlayQueue.Dequeue();isCurrentStatePlayFinished = false;PlayState(currentAnimatorPlayInfo);}float playTime = animator.GetCurrentAnimatorStateInfo(currentAnimatorPlayInfo.layer).normalizedTime;if (playTime > currentAnimatorPlayInfo.endTimeNormalized){if (currentAnimatorPlayInfo.onPlayFinished != null)                    currentAnimatorPlayInfo.onPlayFinished();isCurrentStatePlayFinished = true;}}public void AppendState(AnimatorPlayInfo info){if (info.isClearStateExists){isCurrentStatePlayFinished = true;animatorPlayQueue.Clear();}this.animatorPlayQueue.Enqueue(info);}public void PlayState(AnimatorPlayInfo playInfo){animator.speed = playInfo.speed;animator.Play(playInfo.stateName, playInfo.layer, playInfo.beginTimeNormalized);}}}