/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using System.Linq;namespace PluginIdea.NavgatePlay{public class FollowMode : NavgateModeBase{private JSONStorableFloat stopDistance;private bool lastTargetMarkFlag;private float timer;private Vector3 lastCamPos;public FollowMode(NavgatePlay ower){this.ower = ower;}public override void Init(){Utils.SetupInfoTextNoScroll(ower,Location.GetStr(Location.FollowModeSubTitle), 35, true);stopDistance = Utils.SetupSliderFloat(ower, Location.GetStr(Location.FollowModeStopDistance), 5f, 0f, 20f, true);}public override void OnEnter(){ower.TimerMgr.RemoveAllTimer();ower.CurrentAnimator.gameObject.SetActive(true);ower.SetBoolParamValue("animatorEnabledJSON", true);ower.HudHander.HUDStr = Location.GetStr(Location.HUD_FollowMode);ower.SetCurrentAnimation(ower.IdleAnim, false, 0);ower.CurrentMoveState = MoveState.IDLE;lastTargetMarkFlag = ower.isShowTargetMark.val;ower.isShowTargetMark.val = false;}public override void OnExit(){ower.isShowTargetMark.val = lastTargetMarkFlag;}public override void OnUpdate(){Vector3 targetPos = Utils.CenterCameraTrans.position;Vector3 end = new Vector3(targetPos.x, 0, targetPos.z);Vector3 begin = new Vector3(lastCamPos.x, 0, lastCamPos.z);float dis = Vector3.Distance(begin, end);if (dis > 1){RefreshTaregetPoint(end);lastCamPos = end;}}private void RefreshTaregetPoint(Vector3 targetPoint){ower.MoveToTargetPoint(targetPoint, stopDistance.val);}public override void UnInit(){}}}