/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;namespace PluginIdea.NavgatePlay{public class FindPathMode : NavgateModeBase{private JSONStorableFloat navMeshWidth, navMeshWidthHeight;private JSONStorableFloat navMeshHeightOffset;private JSONStorableBool drawNavMesh;public FindPathMode(NavgatePlay ower){this.ower = ower;}public override void Init(){navMeshWidth = Utils.SetupSliderFloat(ower, "NavMeshWidth", 20, 5, 100, true);navMeshWidthHeight = Utils.SetupSliderFloat(ower, "NavMeshHeight", 20, 5, 100, true);navMeshHeightOffset = Utils.SetupSliderFloat(ower, "NavMeshHeightOffset", 0.2f, 0, 5, true);drawNavMesh = Utils.SetupToggle(ower, "Show NavMesh", true, true);}public override void OnEnter(){ower.CurrentAnimator.applyRootMotion = false;ower.CurrentAnimator.gameObject.SetActive(true);ower.SetBoolParamValue("animatorEnabledJSON", true);ower.HudHander.HUDStr = "HangOut Mode";ower.SetCurrentAnimation(ower.IdleAnim, false, 0);ower.CurrentMoveState = MoveState.IDLE;}public override void OnExit(){ower.CurrentAnimator.applyRootMotion = true;}public override void OnUpdate(){}private void BakeNavMesh(){}public override void OnPostRender(){if (drawNavMesh.val){List<GLQuad3D> q3ds = new List<GLQuad3D>();Vector3 ld = new Vector3(-navMeshWidth.val / 2, navMeshHeightOffset.val, -navMeshWidthHeight.val / 2);Vector3 lu = new Vector3(-navMeshWidth.val / 2, navMeshHeightOffset.val, navMeshWidthHeight.val / 2);Vector3 ru = new Vector3(navMeshWidth.val / 2, navMeshHeightOffset.val, navMeshWidthHeight.val / 2);Vector3 rd = new Vector3(navMeshWidth.val / 2, navMeshHeightOffset.val, -navMeshWidthHeight.val / 2);q3ds.Add(new GLQuad3D(){ld = ld, lu = lu, rd = rd, ru = ru, color = new Color(0, 0.8f, 0, 0.1f)});GLDrawHelper.DrawQuad3D(q3ds);}}public override void UnInit(){}}}